import { Children, Component, PropTypes } from 'react';

export default class EventListener extends Component {
  componentDidMount() {
    this.props.target.addEventListener(
      this.props.eventName,
      this.props.callback
    )
  }

  componentWillUnmount() {
    this.props.target.removeEventListener(
      this.props.eventName,
      this.props.callback
    )
  }

  render() {
    if (this.props.children)
      return Children.only(this.props.children)

    return null
  }
}

EventListener.propTypes = {
  eventName: PropTypes.string.isRequired,
  callback: PropTypes.func.isRequired,
  target: PropTypes.object.isRequired,
}

EventListener.defaultProps = {
  target: document,
}
